% ------------------------------------------------------------------------------
% Copyright (c) 2019, 2025 Contributors to the Eclipse Foundation
%
% See the NOTICE file(s) distributed with this work for additional
% information regarding copyright ownership.
%
% This program and the accompanying materials are made available under the terms
% of the MIT License which is available at https://opensource.org/licenses/MIT
%
% SPDX-License-Identifier: MIT
% ------------------------------------------------------------------------------
\documentclass{article}
\usepackage{tikz}
\usetikzlibrary{arrows.meta, arrows, automata, positioning, shapes, shapes.misc}
\usepackage[paperwidth=40in, paperheight=20in]{geometry}

\begin{document}
\pagestyle{empty}

\begin{tikzpicture}[
    auto,
    ->,
    node distance=3.5cm,
    every state/.style={ellipse, semithick, fill=black!5, minimum size=1.5cm, font=\Large},
    initial distance=1.2cm,
    every initial by arrow/.style={-{Stealth[scale=1.4]}},
    initial text=,
    transform shape,
    double distance=2pt,
    every loop/.style={min distance=10mm}
]

\node[state, initial above, initial text={$\mathtt{ship\_count} = 0$}] (A) {};

\path[-{Stealth[scale=1.4]}]
    (A) edge[loop left] node[align=center] {$\mathtt{ship\_count} < 4$\\\texttt{ship\_enters}\\$\mathtt{ship\_count} := \mathtt{ship\_count} + 1$} (A)
    (A) edge[loop right]  node[align=center] {$\mathtt{ship\_count} > 0$\\\texttt{ship\_leaves}\\$\mathtt{ship\_count} := \mathtt{ship\_count} - 1$} (A)
;

\end{tikzpicture}
\end{document}
